##
## genhwerror.pl
##
## Written by Ian Buck
## 6/15/2000
## http://graphics.stanford.edu/software/wiregl
##
## Copyright 2000 
## The Board of Trustees of The Leland Stanford Junior University.
## All rights reserved.
##
## Except for commercial resale, lease, license or other commercial
## transactions, permission is hereby given to use, copy, and/or
## modify this software, provided that the above copyright notice and
## this permission notice appear in all copies of this software.  No
## part of this software or any derivatives thereof may be used in
## graphics systems for resale or for use in a commercial product.
##
## This software is provided "as is" and without warranty of any kind,
## express, implied or otherwise, including without limitation, any
## warranty of merchantability or fitness for a particular purpose.
##

$name = shift @ARGV;

print << 'EOF';
/*
** glhwerror.c
**
** Generated by genhwerror.pl
** Created by Ian Buck 11/11/99
**
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000 
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
*/

#include "glcontext.h"
#include "glerror.h"
#include "glhw.h"

typedef void (*glfunc)();

EOF

open (FILE, $name);

loop1: while ($line = <FILE>) {
	chomp $line;
    next loop1 if ($line eq "");
	print "void\n";
	print "__glhwerror_$line (void) {\n";
	print "\t__glerror(__LINE__, __FILE__, GL_NO_ERROR, \"Unbound call: $line\");\n";
	print "\texit(0);\n";
	print "}\n\n";
}


print "GLapi hwerror[] = {\n";

open (FILE, $name);

loop2: while ($line = <FILE>) {
	chomp $line;
    next loop2 if ($line eq "");
	print "\t{\"gl$line\", \t(GLfunc) __glhwerror_$line},\n";
}

print "\t{NULL, NULL}\n";
print "};\n\n";	
