/*
** glscissor.h
**
** Written by Ian Buck
** 6/15/2000
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
*/

#ifndef GLSCISSOR_H
#define GLSCISSOR_H

#include "gltypes.h"
#include "glconfig.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	GLbitvalue enable;
	GLbitvalue rect;
	GLbitvalue dirty;
} GLscissorbits;

typedef struct {
	GLboolean	scissortest;
	GLint		x;
	GLint		y;
	GLsizei		width;
	GLsizei		height;
	GLfloat		widthscale;
	GLfloat		heightscale;
	GLrecti		outputdims;
} GLscissorstate;

void __glscissor_initbits (GLscissorbits *s, GLconfig *c);
void __glscissor_switch (GLscissorbits *s, GLbitvalue bitID,
						  GLscissorstate *current, GLscissorstate *target);
void __glscissor_sync (GLscissorbits *s, GLbitvalue bitID,
						  GLscissorstate *current, GLscissorstate *target);
void __glscissor_clamp (GLscissorstate *c, GLscissorstate *t, GLrecti *p);
void __glscissor_init (GLscissorstate *s, GLconfig *c);
void __glscissor_destroy (GLscissorstate *);

void GLSTATE_DECL __glstate_Scissor (GLint x, GLint y, 
					 GLsizei width, GLsizei height);

void GLSTATE_DECL __gltrack_Scissor (GLint x, GLint y, 
					 GLsizei width, GLsizei height);

#ifdef __cplusplus
}
#endif

#endif
