/*
** util/devnull.c
** Generated by opengl_stub/windows_exports.py
** http://graphics.stanford.edu/software/wiregl
**
** Copyright 2000 
** The Board of Trustees of The Leland Stanford Junior University.
** All rights reserved.
**
** Except for commercial resale, lease, license or other commercial
** transactions, permission is hereby given to use, copy, and/or
** modify this software, provided that the above copyright notice and
** this permission notice appear in all copies of this software.  No
** part of this software or any derivatives thereof may be used in
** graphics systems for resale or for use in a commercial product.
**
** This software is provided "as is" and without warranty of any kind,
** express, implied or otherwise, including without limitation, any
** warranty of merchantability or fitness for a particular purpose.
**
*/

#include "__utilsource.h"

#include "wiregl/include/wiregl_util.h"

static struct {
	int                  initialized;
	WireGLBufferPool     bufpool;
	WireGLLock           lock;
	WireGLNetReceiveFunc recv;
	WireGLNetCloseFunc   close;
} wiregl_devnull;

UTIL_DECL void *
wireGLDevNullAlloc( void )
{
	void *buf = wireGLBufferPoolPop( &wiregl_devnull.bufpool );
	if ( buf == NULL )
	{
		buf = wireGLAlloc( __wiregl_max_send + sizeof(int) );
		/* skip over the space for the length field */
		buf = (int *) buf + 1;
	}
	return buf;
}


UTIL_DECL void
wireGLDevNullFlowControl( WireGLConnection *conn, int enable )
{
	(void) conn;
	(void) enable;
}


UTIL_DECL void 
wireGLDevNullSend( WireGLConnection *conn, void **bufp,
				 void *start, unsigned int len )
{
	unsigned int *lenp = (unsigned int *) start - 1;
	*lenp = len;
	(void) start;
	(void) conn;
#if 0
	wireGLLogWrite( len );
#endif

	/* reclaim this pointer for reuse and try to keep the client from
	   accidentally reusing it directly */
	wireGLBufferPoolPush( &wiregl_devnull.bufpool, *bufp );
	*bufp = NULL;
}

UTIL_DECL int
wireGLDevNullRecv( void )
{
	return 0;
}


UTIL_DECL void
wireGLDevNullInit( WireGLNetReceiveFunc recvFunc, WireGLNetCloseFunc closeFunc )
{
	if ( wiregl_devnull.initialized )
	{
		wireGLAssert( wiregl_devnull.recv == recvFunc );
		wireGLAssert( wiregl_devnull.close == closeFunc );
		return;
	}

#if 0
	wireGLLogOpen( );
#endif

	wireGLBufferPoolInit( &wiregl_devnull.bufpool, 16 );
	wireGLInitLock( &wiregl_devnull.lock );

	wiregl_devnull.recv = recvFunc;
	wiregl_devnull.close = closeFunc;

	wiregl_devnull.initialized = 1;
}

UTIL_DECL void 
wireGLDevNullConnection( WireGLConnection *conn )
{
	wireGLAssert( wiregl_devnull.initialized );

    conn->type        = WIREGL_DROP_PACKETS;
	conn->Alloc  	  = wireGLDevNullAlloc;
	conn->Send   	  = wireGLDevNullSend;
	conn->FlowControl = wireGLDevNullFlowControl;

}


